Package org.opensaml.saml.saml2.profile.impl

# Class AddChannelBindingsToAssertions

java.lang.Object
net.shibboleth.shared.component.AbstractInitializableComponent
org.opensaml.profile.action.AbstractProfileAction
org.opensaml.profile.action.AbstractConditionalProfileAction
org.opensaml.saml.saml2.profile.impl.AddChannelBindingsToAssertions

All Implemented Interfaces:
  `Component`, `DestructableComponent`, `InitializableComponent`, `ProfileAction`

public class AddChannelBindingsToAssertions extends AbstractConditionalProfileAction
Action to add `ChannelBindings` extension(s) to every `Assertion` in a `Response` message.

If the containing `Advice` is not present, it will be created.

The `ChannelBindingsContext` to read from is located via lookup strategy, by default beneath the outbound message context.

Event:
  `EventIds.PROCEED_EVENT_ID`, `EventIds.INVALID_MSG_CTX`

## Field Summary

Fields
Modifier and Type
Field
Description
`private ChannelBindingsContext`
`channelBindingsContext`
ChannelBindingsContext to read from.
`private Function<ProfileRequestContext,ChannelBindingsContext>`
`channelBindingsContextLookupStrategy`
Strategy used to locate the `ChannelBindingsContext` to operate on.
`private final org.slf4j.Logger`
`log`
Class logger.
`private Response`
`response`
Response to modify.
`private Function<ProfileRequestContext,Response>`
`responseLookupStrategy`
Strategy used to locate the `Response` to operate on.

## Constructor Summary

Constructors
Constructor
Description
`AddChannelBindingsToAssertions()`
Constructor.

## Method Summary

Modifier and Type
Method
Description
`protected void`
`doExecute(ProfileRequestContext profileRequestContext)`
Performs this action.
`protected boolean`
`doPreExecute(ProfileRequestContext profileRequestContext)`
Called prior to execution, actions may override this method to perform pre-processing for a request.
`void`
`setChannelBindingsContextLookupStrategy(Function<ProfileRequestContext,ChannelBindingsContext> strategy)`
Set the strategy used to locate the `ChannelBindingsContext` to operate on.
`void`
`setResponseLookupStrategy(Function<ProfileRequestContext,Response> strategy)`
Set the strategy used to locate the `Response` to operate on.

### Methods inherited from class org.opensaml.profile.action.AbstractConditionalProfileAction

`getActivationCondition, setActivationCondition`

### Methods inherited from class org.opensaml.profile.action.AbstractProfileAction

`doPostExecute, doPostExecute, ensureHttpServletRequest, ensureHttpServletResponse, execute, getHttpServletRequest, getHttpServletRequestSupplier, getHttpServletResponse, getHttpServletResponseSupplier, getLogPrefix, isPreExecuteCalled, setHttpServletRequestSupplier, setHttpServletResponseSupplier`

### Methods inherited from class net.shibboleth.shared.component.AbstractInitializableComponent

`checkComponentActive, checkSetterPreconditions, destroy, doDestroy, doInitialize, ifDestroyedThrowDestroyedComponentException, ifInitializedThrowUnmodifiabledComponentException, ifNotInitializedThrowUninitializedComponentException, initialize, isDestroyed, isInitialized`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface net.shibboleth.shared.component.InitializableComponent

`initialize, isInitialized`

## Field Details

### log

@Nonnull private final org.slf4j.Logger log
Class logger.

### channelBindingsContextLookupStrategy

@Nonnull private Function<ProfileRequestContext,ChannelBindingsContext> channelBindingsContextLookupStrategy
Strategy used to locate the `ChannelBindingsContext` to operate on.

### responseLookupStrategy

@Nonnull private Function<ProfileRequestContext,Response> responseLookupStrategy
Strategy used to locate the `Response` to operate on.

### channelBindingsContext

@NonnullBeforeExec private ChannelBindingsContext channelBindingsContext
ChannelBindingsContext to read from.

### response

@NonnullBeforeExec private Response response
Response to modify.

## Constructor Details

### AddChannelBindingsToAssertions

public AddChannelBindingsToAssertions()
Constructor.

## Method Details

### setChannelBindingsContextLookupStrategy

public void setChannelBindingsContextLookupStrategy(@Nonnull Function<ProfileRequestContext,ChannelBindingsContext> strategy)
Set the strategy used to locate the `ChannelBindingsContext` to operate on.

Parameters:
  `strategy` - lookup strategy

### setResponseLookupStrategy

public void setResponseLookupStrategy(@Nonnull Function<ProfileRequestContext,Response> strategy)
Set the strategy used to locate the `Response` to operate on.

Parameters:
  `strategy` - lookup strategy

### doPreExecute

protected boolean doPreExecute(@Nonnull ProfileRequestContext profileRequestContext)
Called prior to execution, actions may override this method to perform pre-processing for a request.

If false is returned, execution will not proceed, and the action should attach an `EventContext` to the context tree to signal how to continue with overall workflow processing.

If returning successfully, the last step should be to return the result of the superclass version of this method.

Overrides:
  `doPreExecute` in class `AbstractConditionalProfileAction`
Parameters:
  `profileRequestContext` - the current IdP profile request context
Returns:
  true iff execution should proceed

### doExecute

protected void doExecute(@Nonnull ProfileRequestContext profileRequestContext)
Performs this action. Actions must override this method to perform their work.

Overrides:
  `doExecute` in class `AbstractProfileAction`
Parameters:
  `profileRequestContext` - the current IdP profile request context